#!/usr/bin/env bash

# Function to pause and wait for user input
pause() {
    read -p "$*"
}

# ANSI escape codes for bold and white text
BOLD_WHITE="\033[1;37m"
RESET="\033[0m"

# Instructions for the user
echo -e "${BOLD_WHITE}Welcome to the BB-GPT-v1.0 installer.${RESET}"
echo -e "${BOLD_WHITE}Please ensure you have made this script executable by running:${RESET}"
echo -e "${BOLD_WHITE}chmod +x install.sh${RESET}"
pause "Press [Enter] to continue or close this terminal and run the chmod command..."

# Directories to check
USR_DIR="$HOME/usr"
LOCAL_DIR="$HOME/usr/local"
BIN_DIR="$HOME/usr/local/bin"

# Check if the directories exist, and create them if necessary
echo -e "${BOLD_WHITE}Checking necessary directories...${RESET}"
[ -d "$USR_DIR" ] || mkdir "$USR_DIR"
[ -d "$LOCAL_DIR" ] || mkdir "$LOCAL_DIR"
[ -d "$BIN_DIR" ] || mkdir "$BIN_DIR"
echo -e "${BOLD_WHITE}Directories are set up.${RESET}"

# Move the gpt script to the bin directory
echo -e "${BOLD_WHITE}Moving the gpt script to $BIN_DIR...${RESET}"
cp gpt "$BIN_DIR/gpt"
chmod +x "$BIN_DIR/gpt"
echo -e "${BOLD_WHITE}gpt script moved and made executable.${RESET}"

# Ask the user for the OpenAI API key
read -p "Please enter your OpenAI API key: " OPENAI_API_KEY

# Update the gpt script with the provided API key
echo -e "${BOLD_WHITE}Updating the gpt script with your API key...${RESET}"
sed -i.bak "s|OPENAIKEY=\"your-openai-api-key-here\"|OPENAIKEY=\"$OPENAI_API_KEY\"|" "$BIN_DIR/gpt"
echo -e "${BOLD_WHITE}API key updated successfully.${RESET}"

# Update the .profile to include the bin directory in the PATH
PROFILE_FILE="$HOME/.profile"
if ! grep -q 'export PATH="$HOME/usr/local/bin:$PATH"' "$PROFILE_FILE"; then
    echo 'export PATH="$HOME/usr/local/bin:$PATH"' >> "$PROFILE_FILE"
    echo -e "${BOLD_WHITE}Updated .profile with new PATH.${RESET}"
else
    echo -e "${BOLD_WHITE}.profile already contains the necessary PATH.${RESET}"
fi

echo -e "${BOLD_WHITE}Added user message to .profile.${RESET}"

# Final instructions
echo -e "${BOLD_WHITE}Installation complete!${RESET}"
echo -e "${BOLD_WHITE}You can now run the gpt command from your terminal.${RESET}"

echo -e "${BOLD_WHITE}Powered by sw7ft follow at Patreon.${RESET}"

echo -e "${BOLD_WHITE}PLEASE CLOSE TERM 49 and REOPEN ${RESET}"

